///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit LmpLeversForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TLmpLeversF = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;



var
  LmpLeversF: TLmpLeversF;
  PathForForm, MaskaNam, FileNam, Unknown1, ShablonsPath : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.DFM}

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to LmpLeversF.MaskiBox.Items.Capacity-1 do begin
    If LmpLeversF.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to LmpLeversF.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If LmpLeversF.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;





procedure TLmpLeversF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  LmpLeversFClosed := true;
  MainForm.LmpLeversMenu.Checked := false;
  Action := CaFree;
end;




procedure TLmpLeversF.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LmpLeversF.LoadFil(PathForForm+FileNam,Sender);
end;

procedure TLmpLeversF.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LmpLeversF.LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TLmpLeversF.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
begin
  Cascade;
  ActivateTable(Sender);
  //  
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .

  //Name - 1  TEXT
  BufSt := Zap1.GetField(1);
  BufSiz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,1] := PzDbStrToStr(BufSt);

  //Places -  2.  PLACES
  BufSt := Zap1.GetField(2);
  BufSiz := Zap1.SizFieldOtv;
  // 4 . ...
  ChB[1] := Byte(BufSt[1]);
  ChB[2] := Byte(BufSt[2]);
  ChB[3] := Byte(BufSt[3]);
  ChB[4] := Byte(BufSt[4]);
  Flt := GetFloat(ChB);
  ValuesEd.Cells[1,2] := FloatToStrMy(RoundFloat(Flt,7));
  //...  FOAT
  ChB[1] := Byte(BufSt[5]);
  ChB[2] := Byte(BufSt[6]);
  ChB[3] := Byte(BufSt[7]);
  ChB[4] := Byte(BufSt[8]);
  Flt := GetFloat(ChB);
  ValuesEd.Cells[1,3] := FloatToStrMy(RoundFloat(Flt,7));
  //...  FLOAT
  ChB[1] := Byte(BufSt[9]);
  ChB[2] := Byte(BufSt[10]);
  ChB[3] := Byte(BufSt[11]);
  ChB[4] := Byte(BufSt[12]);
  Flt := GetFloat(ChB);
  ValuesEd.Cells[1,4] := FloatToStrMy(RoundFloat(Flt,7));
  //...  FLOAT
  ChB[1] := Byte(BufSt[13]);
  ChB[2] := Byte(BufSt[14]);
  ChB[3] := Byte(BufSt[15]);
  ChB[4] := Byte(BufSt[16]);
  Flt := GetFloat(ChB);
  ValuesEd.Cells[1,5] := FloatToStrMy(RoundFloat(Flt,7));

  //  UnsignedLong -  3.  UNSIGNEDLONG
  BufSt := Zap1.GetField(3);
  BufSiz := Zap1.SizFieldOtv;
  Unknown1 := BufSt;  //  .
  //   .
  ValuesEd.Cells[1,6] := IntToStr(_4byteStrToUnsLong(BufSt));

  //Scale -  4. FLOAT
  BufSt := Zap1.GetField(4);
  BufSiz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,7] := FloatToStrMy(RoundFloat(_4byteStrToFloat(BufSt),7));

  //Switch Time -  5. TIME
  BufSt := Zap1.GetField(5);
  BufSiz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,8] := FloatToStrMy(RoundFloat(_4byteStrToTime(BufSt),7));

  //Material -  6. TEXT
  BufSt := Zap1.GetField(6);
  BufSiz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,9] := PzDbStrToStr(BufSt);

  //SwitchSound -  7. TEXT
  BufSt := Zap1.GetField(7);
  BufSiz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,10] := PzDbStrToStr(BufSt);

  //LeverDescription -  8. TEXT
  BufSt := Zap1.GetField(8);
  BufSiz := Zap1.SizFieldOtv;
  BufSt := PzDbStrToStr(BufSt);
  StToText := '';
  // 2 ,  ...
  For I := 1 to 24 do begin
    //   - 24 .  ...
    If BufSt[I] <> ' ' then StToText := StToText+BufSt[I];
  end;
  I := 23;
  ValuesEd.Cells[1,11] := StToText;
  StToText := '';
  //...
  repeat
    I := I+1;
    If BufSt[I] <> #0 then StToText := StToText+BufSt[I];
  until BufSt[I] = #0;
  ValuesEd.Cells[1,12] := StToText;
end;

Function TLmpLeversF.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //NameEd.SetFocus;
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;
  if CheckStrFloat(ValuesEd.Cells[1,2]) = false then begin
    AllOk := false;
    //Place1_1Ed.SetFocus;
    ValuesEd.Selection := SelGridRect(1,2);
    ErrorMsgStr := '    .';
    Beep;
  end;
  if CheckStrFloat(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Place1_2Ed.SetFocus;
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end;
  if CheckStrFloat(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Place2_1Ed.SetFocus;
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;
  if CheckStrFloat(ValuesEd.Cells[1,5]) = false then begin
    AllOk := false;
    //Place2_2Ed.SetFocus;
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;
  if CheckStrInt(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Un1Ed.SetFocus;
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;
  if CheckStrFloat(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //ScaleEd.SetFocus;
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;
  if CheckStrFloat(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //SwitchTimeEd.SetFocus;
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;
  If CheckStrPredel(ValuesEd.Cells[1,11],24) = false then begin
    AllOk := false;
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '     -      24 .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin
  
    //Name. 1. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,1]);
    //  ...
    Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Places. 2. ( 4 ).
    BufSt := '';
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,2]));
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,3]));
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,4]));
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,5]));
    SizBufSt := 16;
    //  ...
    Zap1.ReWriteField(2,SizBufSt,BufSt);
    
    // . 3. UnsLong

    //   -    
    // ,    .
    //  (   )   
    //.   ,   
    //     - ,    .

    // -  .

    BufSt1 := IntToStr(StrToInt(ValuesEd.Cells[1,6]));
    BufSt2 := IntToStr(_4byteStrToUnsLong(Unknown1));
    If BufSt1 = BufSt2 then begin
      //  -      
      BufSt := Unknown1;
    end
    else begin
      // -    .
      BufSt := UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,6]));
      //   !!!!!
      Unknown1 := BufSt;
    end;
    //     .
    SizBufSt := 4;
    //  ...
    Zap1.ReWriteField(3,SizBufSt,BufSt);

    //Scale. 4. Float
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,7]));
    SizBufSt := 4;
    //  ...
    Zap1.ReWriteField(4,SizBufSt,BufSt);

    //SwitchTime 5. TIME.
    BufSt := TimeTo4byteStr(StrToFloat2(ValuesEd.Cells[1,8]));
    SizBufSt := 4;
    //  ...
    Zap1.ReWriteField(5,SizBufSt,BufSt);
    
    //Material. 6. TEXT.
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,9]);
    //  ...
    Zap1.ReWriteField(6,PzDbStrRec.Siz,PzDbStrRec.Str);

    //SwitchSound. 7. TEXT.
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,10]);
    //  ...
    Zap1.ReWriteField(7,PzDbStrRec.Siz,PzDbStrRec.Str);

    //LeverDescription. 8.  TEXT.      2  .
    //   ...
    I := 0;
    BufSt := '';
    Res1St := '';
    SizBufSt := 0;
    I := 0;
    //  ...
    If ValuesEd.Cells[1,11] <> '' then begin
      repeat
        I := I+1;
        bf1 := ValuesEd.Cells[1,11][I];
        If bf1 <> #0 then begin
          Res1St := Res1St+bf1;
        end;
      until bf1 = #0;
      I := I-1;
    end;
    //     24 ...
    If I <> 24 then begin
      repeat
        I := I+1;
        Res1St := Res1St+' ';
      until I = 24;
    end;
    // 2- ...
    Res1St := Res1St+ValuesEd.Cells[1,12];
    //        ...
    I := 0;
    SizBufSt := 0;
    If Res1St <> '' then begin
      repeat
        I := I+1;
        bf1 := Res1St[I];
        BufSt := BufSt+bf1;
        sizBufSt := SizBufSt+1;
      until bf1 = #0;
    end
    else begin
      I := 1;
      BufSt := ''+#0;
    end;
    //  ...
    Zap1.ReWriteField(8,SizBufSt,BufSt);

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

procedure TLmpLeversF.FormShow(Sender: TObject);
var
  I, J : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  LmpLeversFClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  
  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaselmpResIsh;     //  
  PathForForm := IshDir+'levers\1\';     //   
  ShablonsPath := Path+'shablons\levers\1\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TLmpLeversF.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;  
end;

procedure TLmpLeversF.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TLmpLeversF.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TLmpLeversF.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TLmpLeversF.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

Procedure TLmpLeversF.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[5].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TLmpLeversF.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[5].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

procedure TLmpLeversF.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 6 then begin
      //1,   UnsLong.  4 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown1;
      UncAskF.UncAskFBytes := 4;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown1 := UncAskF.UncAskFBuff;
          ValuesEd.Cells[1,6] := IntToStr(_4byteStrToUnsLong(Unknown1));
        end;
      end;
    end;

  end;
end;

procedure TLmpLeversF.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
