///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ResPathsForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TResPathsF = class(TForm)
    FileNamesBox: TListBox;
    FilePathEd: TEdit;
    BrowseBut: TButton;
    OkBut: TButton;
    CancelBut: TButton;
    SavePathBut: TButton;
    SDD1: TSaveDialog;
    procedure OkButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FileNamesBoxClick(Sender: TObject);
    procedure SavePathButClick(Sender: TObject);
    procedure FilePathEdChange(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BrowseButClick(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateFormElements(Sender: TObject);
  public
    { Public declarations }
  end;

var
  ResPathsF: TResPathsF;

implementation
uses KOL, initer;

const
  ResFilNamesNumber = 14;
  ResFilNames : array [1..ResFilNamesNumber] of string = ('aiinfo.res','database.res','databaselmp.res',
  'figures.res','gfx.res','materials.res','menus.res','outro.res','redress.res','sfx.res',
  'speech.res','texts.res','textslmp.res','textures.res');

var
  ResFilPaths : array [1..ResFilNamesNumber] of string;
  ValueChanged : boolean;

{$R *.dfm}

procedure TResPathsF.OkButClick(Sender: TObject);
begin
  //   -       
  // +  ini-.

  //  -    ...
  AiinfoResPath := ResFilPaths[1];
  DatabaseResPath := ResFilPaths[2];
  DatabaselmpResPath := ResFilPaths[3];
  FiguresResPath := ResFilPaths[4];
  GfxResPath := ResFilPaths[5];
  MaterialsResPath := ResFilPaths[6];
  MenusResPath := ResFilPaths[7];
  OutroResPath := ResFilPaths[8];
  RedressResPath := ResFilPaths[9];
  SfxResPath := ResFilPaths[10];
  SpeechResPath := ResFilPaths[11];
  TextsResPath := ResFilPaths[12];
  TextslmpResPath := ResFilPaths[13];
  TexturesResPath := ResFilPaths[14];

  //      ini-...
  AnIniFil.Load(IniFilPath);  // .
  AnIniFil.WriteString('MainSettings','AiinfoResPath',AiinfoResPath);
  AnIniFil.WriteString('MainSettings','DatabaseResPath',DatabaseResPath);
  AnIniFil.WriteString('MainSettings','DatabaselmpResPath',DatabaselmpResPath);
  AnIniFil.WriteString('MainSettings','FiguresResPath',FiguresResPath);
  AnIniFil.WriteString('MainSettings','GfxResPath',GfxResPath);
  AnIniFil.WriteString('MainSettings','MaterialsResPath',MaterialsResPath);
  AnIniFil.WriteString('MainSettings','MenusResPath',MenusResPath);
  AnIniFil.WriteString('MainSettings','OutroResPath',OutroResPath);
  AnIniFil.WriteString('MainSettings','RedressResPath',RedressResPath);
  AnIniFil.WriteString('MainSettings','SfxResPath',SfxResPath);
  AnIniFil.WriteString('MainSettings','SpeechResPath',SpeechResPath);
  AnIniFil.WriteString('MainSettings','TextsResPath',TextsResPath);
  AnIniFil.WriteString('MainSettings','TextslmpResPath',TextslmpResPath);
  AnIniFil.WriteString('MainSettings','TexturesResPath',TexturesResPath);
  AnIniFil.Save(IniFilPath);  // .    :)

  ModalResult := mrOk;   //     :).
end;

procedure TResPathsF.CancelButClick(Sender: TObject);
begin
  ModalResult := mrCancel
end;

procedure TResPathsF.FormShow(Sender: TObject);
var
  I : integer;
begin
  //  ...

  //     .
  For I := 1 to ResFilNamesNumber do begin
    FileNamesBox.Items.Add(ResFilNames[I]);
  end;

  //     ...
  ResFilPaths[1] := AiinfoResPath;
  ResFilPaths[2] := DatabaseResPath;
  ResFilPaths[3] := DatabaselmpResPath;
  ResFilPaths[4] := FiguresResPath;
  ResFilPaths[5] := GfxResPath;
  ResFilPaths[6] := MaterialsResPath;
  ResFilPaths[7] := MenusResPath;
  ResFilPaths[8] := OutroResPath;
  ResFilPaths[9] := RedressResPath;
  ResFilPaths[10] := SfxResPath;
  ResFilPaths[11] := SpeechResPath;
  ResFilPaths[12] := TextsResPath;
  ResFilPaths[13] := TextslmpResPath;
  ResFilPaths[14] := TexturesResPath;

  //   1-  .
  FileNamesBox.ItemIndex := 0;
  FileNamesBoxClick(Sender);
end;

procedure TResPathsF.FileNamesBoxClick(Sender: TObject);
begin
  //  -         .  
  //   -     .

  FilePathEd.Text := ResFilPaths[FileNamesBox.ItemIndex+1];

  //     \ ...
  ValueChanged := false;
  UpdateFormElements(Sender);
end;

procedure TResPathsF.SavePathButClick(Sender: TObject);
begin
  //   -     ...
  ResFilPaths[FileNamesBox.ItemIndex+1] := FilePathEd.Text;

  //  ...
  ValueChanged := false;
  UpdateFormElements(Sender);
end;

procedure TResPathsF.UpdateFormElements(Sender: TObject);
begin
  //       
  //  .

  //       ,   - ,  
  // - .
  If ValueChanged = false then begin
    OkBut.Enabled := true;
    SavePathBut.Enabled := false;
  end
  else begin
    OkBut.Enabled := false;
    SavePathBut.Enabled := true;
  end;
end;

procedure TResPathsF.FilePathEdChange(Sender: TObject);
begin
  //    ...
  ValueChanged := true;
  UpdateFormElements(Sender);
end;

procedure TResPathsF.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //ShowMessage('');   //      watch-,  .

  //       :).
  If Key = #13 then begin
    //Enter
    If ValueChanged = true then begin
      //  ...
      SavePathButClick(Sender);  //     .
    end
    else begin
      //   -      .
      OkButClick(Sender);
    end;

    //    ...
    Key := #0;
  end;

  If Key = #27 then begin
    //Escape

    //    ,    .
    //    -    .
    If ValueChanged = true then begin
      FilePathEd.Text := ResFilPaths[FileNamesBox.ItemIndex+1];
      ValueChanged := false;
      UpdateFormElements(Sender);
    end
    else begin
      CancelButClick(Sender);
    end;
    //    ...
    Key := #0;
  end;
end;

procedure TResPathsF.BrowseButClick(Sender: TObject);
begin
  //   -       .

  //   ...
  If DirectoryExists(ExtractFilePath(FilePathEd.Text)) = true then begin
    //  ,       ...
    SDD1.InitialDir := ExtractFilePath(FilePathEd.Text);
  end
  else begin
    SDD1.InitialDir := DefalDir;
  end;

  //   ...
  If SDD1.Execute = true then begin
    // ...
    If DirectoryExists(ExtractFilePath(SDD1.FileName)) = true then begin
      //   ...
      DefalDir := ExtractFilePath(SDD1.FileName);
      AnIniFil.Load(IniFilPath);  // .
      AnIniFil.WriteString('MainSettings','DefalDir',DefalDir);
      AnIniFil.Save(IniFilPath);  // .    :)
    end;

    //   -      ...
    FilePathEd.Text := SDD1.FileName;
  end;  
end;

end.
