///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ShablonimForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, initer, MySys;

type
  TShablonimF = class(TForm)
    Label1: TLabel;
    ShabNamEd: TEdit;
    ShabList: TListBox;
    OkBut: TButton;
    CancelBut: TButton;
    DelBut: TButton;
    procedure OkButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ShabNamEdChange(Sender: TObject);
    procedure ShabListClick(Sender: TObject);
    procedure DelButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ShablsPath : string;
    ShablPath : string;
  end;

var
  ShablonimF: TShablonimF;

implementation

{$R *.dfm}

procedure TShablonimF.OkButClick(Sender: TObject);
var
  AllOk : boolean;
begin
  //  .      
  //  -   
  //  -      .
  AllOk := true;
  If FileExists(ShablsPath+ShabNamEd.Text+'.zap') = true then begin
    If MessageDLG('     .    ?',mtWarning,[mbYes]+[mbCancel],0) = mrCancel then begin
      // 
      AllOk := false;
    end;
  end;
  If AllOk then begin
    ShablPath := ShablsPath+ShabNamEd.Text+'.zap';
    ModalResult := mrOk;
  end;
end;

procedure TShablonimF.CancelButClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TShablonimF.FormShow(Sender: TObject);
var
  SRec : TSearchRec;
  Old : string;
begin
  //   -      .

  //.
  ShabNamEd.Clear;
  ShabList.Clear;

  // .
  findFirst(ShablsPath+'*.zap',FaAnyFile,SRec);
  If SRec.Name <> '' then ShabList.Items.Add(GetFileName(SRec.Name));
  repeat
    old := SRec.name;
    FindNext(SRec);
    If SRec.Name <> old then ShabList.Items.Add(GetFileName(SRec.Name));
  until old = SRec.name;
  FindClose(SRec);

  //  OK  .
  OkBut.Enabled := false;
  DelBut.Enabled := false;
end;

procedure TShablonimF.ShabNamEdChange(Sender: TObject);
var
  I : integer;
  Finded : boolean;
begin
  //     
  //  -    OK
  //     .
  if ShabNamEd.text = '' then begin
    OkBut.Enabled := false;
    DelBut.Enabled := false;
  end
  else begin
    OkBut.Enabled := true;
    Finded := false;
    For I := 1 to ShabList.Items.Capacity do begin
      If ShabNamEd.Text = ShabList.Items[I-1] then begin
        ShabList.ItemIndex := I-1;
        Finded := true;
        DelBut.Enabled := true;
      end;
    end;
    If Finded = false then begin
      For I := 1 to ShabList.Items.Capacity do begin
        ShabList.Selected[I-1] := false;
        DelBut.Enabled := false;
      end;
    end;
  end;
end;

procedure TShablonimF.ShabListClick(Sender: TObject);
begin
  ShabNamEd.Text := ShabList.Items[ShabList.ItemIndex];
end;

procedure TShablonimF.DelButClick(Sender: TObject);
begin
  If MessageDLG(' ?',mtWarning,[mbYes]+[mbNo],0) = mrYes then begin
    If FileExists(ShablsPath+ShabNamEd.Text+'.zap') = true then begin
      //  ...
      DeleteFile(ShablsPath+ShabNamEd.Text+'.zap');
      //  ...
      FormShow(Sender);
    end;
  end;
end;

end.
