///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SinglQuestsQdbR1Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSinglQuestsQdbR1F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SinglQuestsQdbR1F: TSinglQuestsQdbR1F;
  PathForForm, MaskaNam, FileNam,ShablonsPath,
  Unknown1, Unknown2 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz : integer;


implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSinglQuestsQdbR1F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SinglQuestsQdbR1FClosed := true;
  MainForm.QuestsMenu1.Checked := false;
  Action := CaFree;
end;

procedure TSinglQuestsQdbR1F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SinglQuestsQdbR1FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaseResIsh;     //  
  PathForForm := IshDir+'quests\1\';     //   
  ShablonsPath := Path+'shablons\quests\1\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            //MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;

        //  (       )
        //   
        //  ...
        Num := _4byteStrToUnsLong(Zap1.GetField(7));
        If Num <> I then begin
          //   ....
          //...
          Num := I;
          Zap1.ReWriteField(7,4,UnsLongTo4byteStr(Num));
          Zap1.BuildZap;
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+Indeks[I,1]);
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TSinglQuestsQdbR1F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  MaskaNam := MaskiBox.Text;
  FileNam := FilesBox.Items[MaskiBox.ItemIndex];
  //   
  FilesBox.ItemIndex := MaskiBox.ItemIndex;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TSinglQuestsQdbR1F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  FileNam := FilesBox.Text;
  FileNam := FilesBox.Items[FilesBox.ItemIndex];
  //   
  MaskiBox.ItemIndex := FilesBox.ItemIndex;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSinglQuestsQdbR1F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Experience -  2  FLOAT. ( )
  ValuesEd.Cells[1,2] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(2)),7));

  //Unknown1 -  3   ,  4  .
  Unknown1 := Zap1.GetField(3);
  Unk1Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,3] := GetUnkStr(Unknown1,Unk1Siz);

  //Zone Number -  4  UnsLong.
  ValuesEd.Cells[1,4] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(4)));

  //Comment -  5  TEXT.
  ValuesEd.Cells[1,5] := PzDbStrToStr(Zap1.GetField(5));

  //Money -  6  FLOAT. ( )
  ValuesEd.Cells[1,6] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(6)),7));

  //RecordNum -  7  UnsLong.
  ValuesEd.Cells[1,7] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(7)));

  //Unknown2 -  8   ,  4  .
  Unknown2 := Zap1.GetField(8);
  Unk2Siz := Zap1.SizFieldOtv;
  ValuesEd.Cells[1,8] := GetUnkStr(Unknown2,Unk2Siz);
end;

Function TSinglQuestsQdbR1F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';
  
  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,2]) = false then begin
    AllOk := false;
    //Experience
    ValuesEd.Selection := SelGridRect(1,2);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Zone Number
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Money
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //RecordNum -  
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end
  else if StrToInt(ValuesEd.Cells[1,7]) <> MaskiBox.ItemIndex+1 then begin
    AllOk := false;
    //RecordNum -   .
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '       .    '+IntToStr(MaskiBox.ItemIndex+1);
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,1]);
    //  ...
    Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Experience.  2. FLOAT.
    Zap1.ReWriteField(2,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,2])));

    //Unknown1.  3.    .
    Zap1.ReWriteField(3,Unk1Siz,Unknown1);

    //Zone Number.  4. UnsLong.
    Zap1.ReWriteField(4,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,4])));

    //Comment.  5. TEXT.
    // - ...
    PzDbStrRec := StrToPzDbStr(ValuesEd.Cells[1,5]);
    //  ...
    Zap1.ReWriteField(5,PzDbStrRec.Siz,PzDbStrRec.Str);

    //Money.  6. FLOAT.
    Zap1.ReWriteField(6,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,6])));

    //RecordNum.  7. UnsLong.
    Zap1.ReWriteField(7,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,7])));

    //Unknown2.  8.    .
    Zap1.ReWriteField(8,Unk2Siz,Unknown2);

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSinglQuestsQdbR1F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[2].EditStyle := esEllipsis;
    ValuesEd.ItemProps[7].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TSinglQuestsQdbR1F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[2].EditStyle := esSimple;
    ValuesEd.ItemProps[7].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  if Maska <> 'dummy' then begin    // dummy -   
    For J := 0 to SinglQuestsQdbR1F.MaskiBox.Items.Capacity-1 do begin
      If SinglQuestsQdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
    end;
  end;  
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  if Maska <> 'dummy' then begin     // dummy -   
    For J := 0 to SinglQuestsQdbR1F.MaskiBox.Items.Capacity-1 do begin
      If J <> IndAcr then If SinglQuestsQdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
    end;
  end;  
end;

procedure TSinglQuestsQdbR1F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TSinglQuestsQdbR1F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TSinglQuestsQdbR1F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TSinglQuestsQdbR1F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TSinglQuestsQdbR1F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSinglQuestsQdbR1F.ValuesEdEditButtonClick(Sender: TObject);
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 3 then begin
      //1, 4 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown1;
      UncAskF.UncAskFBytes := Unk1Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown1 := UncAskF.UncAskFBuff;
          Unk1Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,3] := GetUnkStr(Unknown1,Unk1Siz);
        end;
      end;
    end;

    If ValuesEd.Row = 8 then begin
      //2 0 .
      //,     ...
      UncAskF.UncAskFBuff := Unknown2;
      UncAskF.UncAskFBytes := Unk2Siz;
      UncAskFLetChangSiz := true; //  ...
      UncAskF.ShowModal;
      If UncAskF.ModalResult = mrOk then begin
        // 
        If UncAskFSaved = false then begin
          //  ...
          //     .
          Unknown2 := UncAskF.UncAskFBuff;
          Unk2Siz := UncAskF.UncAskFBytes;
          ValuesEd.Cells[1,8] := GetUnkStr(Unknown2,Unk2Siz);
        end;
      end;
    end;

  end;
end;

procedure TSinglQuestsQdbR1F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
