///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SpellsSdbR1Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSpellsSdbR1F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SpellsSdbR1F: TSpellsSdbR1F;
  PathForForm, MaskaNam, FileNam, ShablonsPath,
  Unknown1, Unknown2, Unknown3, Unknown4, Unknown5,
  Unknown6 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz, Unk3Siz, Unk4Siz, Unk5Siz,
  Unk6Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSpellsSdbR1F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SpellsSdbR1FClosed := true;
  MainForm.LmpSpellsMenu1.Checked := false;
  Action := CaFree;
end;

procedure TSpellsSdbR1F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SpellsSdbR1FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';
  ValuesEd.Cells[1,21] := '';
  ValuesEd.Cells[1,22] := '';
  ValuesEd.Cells[1,23] := '';
  ValuesEd.Cells[1,24] := '';
  ValuesEd.Cells[1,25] := '';
  ValuesEd.Cells[1,26] := '';
  ValuesEd.Cells[1,27] := '';
  ValuesEd.Cells[1,28] := '';
  ValuesEd.Cells[1,29] := '';
  ValuesEd.Cells[1,30] := '';
  ValuesEd.Cells[1,31] := '';
  ValuesEd.Cells[1,32] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaselmpResIsh;     //  
  PathForForm := IshDir+'spells\1\';     //   
  ShablonsPath := Path+'shablons\spells\1\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TSpellsSdbR1F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TSpellsSdbR1F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSpellsSdbR1F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Code -  2  TEXT.
  ValuesEd.Cells[1,2] := PzDbStrToStr(Zap1.GetField(2));

  //SubType -  3  TEXT.
  ValuesEd.Cells[1,3] := PzDbStrToStr(Zap1.GetField(3));

  //Price -  4  FLOAT.
  ValuesEd.Cells[1,4] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(4)),7));

  //TypeID -  5  UnsLong. - ID.  -...
  BufSt :=  IntToStr(_4byteStrToUnsLong(Zap1.GetField(5)));
  If BufSt = '0' then begin
    BufSt := BufSt+'     ELEMENTAL';
  end;
  If BufSt = '1' then begin
    BufSt := BufSt+'     SENSES';
  end;
  If BufSt = '2' then begin
    BufSt := BufSt+'     ASTRAL';
  end;
  ValuesEd.Cells[1,5] := BufSt;

  //Mana -  6  FLOAT.
  ValuesEd.Cells[1,6] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(6)),7));

  //Slots -  7  UnsLong.
  ValuesEd.Cells[1,7] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(7)));

  //Speed -  8  FLOAT.
  ValuesEd.Cells[1,8] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(8)),7));

  //Range -  9  FLOAT.
  ValuesEd.Cells[1,9] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(9)),7));

  //Area -  10  FLOAT.
  ValuesEd.Cells[1,10] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(10)),7));

  //Effect -  11  FLOAT.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(11)),7));

  //Code -  12  4bTEXT.
  ValuesEd.Cells[1,12] := _4byteStrWth4bTEXT_ToStr(Zap1.GetField(12));

  //Num Targets -  13  UnsLong.
  ValuesEd.Cells[1,13] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(13)));

  //Duration -  14  UnsLong.
  ValuesEd.Cells[1,14] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(14)));

  //Actions -  15  UnsLong.
  ValuesEd.Cells[1,15] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(15)));

  //Require Trace -  16  UnsLong.
  ValuesEd.Cells[1,16] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(16)));

  //Built-in Mods -  17  4bTextList.
  ValuesEd.Cells[1,17] := _4bTEXTListToStr(Zap1.GetField(17));

  //Special Mods -  18  4bTextList.
  ValuesEd.Cells[1,18] := _4bTEXTListToStr(Zap1.GetField(18));

  //Texture Type Index -  19  UnsLong.
  ValuesEd.Cells[1,19] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(19)));

  //Unknown1 -  20  UnsLong.
  ValuesEd.Cells[1,20] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(20)));

  //Mods -  21   -    , 5 BOOLEAN .
  BufSt := Zap1.GetField(21);
  //Range Mod. BYTE. -  1.
  ValuesEd.Cells[1,21] := BoolToStr(_1byteStrToBool(OtkusitStrokeBashku(@BufSt,1)));
  //Targets Mod. BYTE. -  2.
  ValuesEd.Cells[1,22] := BoolToStr(_1byteStrToBool(OtkusitStrokeBashku(@BufSt,1)));
  //Area Mod. BYTE. -  3.
  ValuesEd.Cells[1,23] := BoolToStr(_1byteStrToBool(OtkusitStrokeBashku(@BufSt,1)));
  //Effect Mod. BYTE. -  4.
  ValuesEd.Cells[1,24] := BoolToStr(_1byteStrToBool(OtkusitStrokeBashku(@BufSt,1)));
  //Duration Mod. BYTE. -  5.
  ValuesEd.Cells[1,25] := BoolToStr(_1byteStrToBool(OtkusitStrokeBashku(@BufSt,1)));

  //Complex -  22  UnsLong.
  ValuesEd.Cells[1,26] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(22)));

  //ShopInfo -  23
  ValuesEd.Cells[1,27] := UnsLongToShopInfo(_4byteStrToUnsLong(Zap1.GetField(23)));

  //Unknown2 -  24  FLOAT.
  ValuesEd.Cells[1,28] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(24)),7));

  //Unknown3 -  25  FLOAT.
  ValuesEd.Cells[1,29] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(25)),7));

  //Unknown4 -  26  FLOAT.
  ValuesEd.Cells[1,30] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(26)),7));

  //Unknown5 -  27  FLOAT.
  ValuesEd.Cells[1,31] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(27)),7));

  //Unknown6 -  28  FLOAT.
  ValuesEd.Cells[1,32] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(28)),7));

end;

Function TSpellsSdbR1F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Price
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(FilterValue(ValuesEd.Cells[1,5])) = false then begin
    AllOk := false;
    //TypeID.    !!!
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Mana
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Slots
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //Speed
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //Range
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //Area
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //Effect
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStr4b1bTEXT(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //Target
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .   1  (),   .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //Num Targets
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //Duration
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //Actions
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //Require Trace
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckList(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Built-in Mods
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .'+#13+'       4 .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,17] := ListBezProbelov(ValuesEd.Cells[1,17]);
    if CheckList4bTEXT(ValuesEd.Cells[1,17]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,17);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .'+#13+'       4 .';
      Beep;
    end;
  end;

  if CheckList(ValuesEd.Cells[1,18]) = false then begin
    AllOk := false;
    //Special Mods
    ValuesEd.Selection := SelGridRect(1,18);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .'+#13+'       4 .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,18] := ListBezProbelov(ValuesEd.Cells[1,18]);
    if CheckList4bTEXT(ValuesEd.Cells[1,18]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,18);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .'+#13+'       4 .';
      Beep;
    end;
  end;

  if CheckStrInt(ValuesEd.Cells[1,19]) = false then begin
    AllOk := false;
    //Texture Type Index
    ValuesEd.Selection := SelGridRect(1,19);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,20]) = false then begin
    AllOk := false;
    //Unknown1
    ValuesEd.Selection := SelGridRect(1,20);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,21]) = false then begin
    AllOk := false;
    //Range Mod
    ValuesEd.Selection := SelGridRect(1,21);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,22]) = false then begin
    AllOk := false;
    //Targets Mod
    ValuesEd.Selection := SelGridRect(1,22);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,23]) = false then begin
    AllOk := false;
    //Area Mod
    ValuesEd.Selection := SelGridRect(1,23);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,24]) = false then begin
    AllOk := false;
    //Effect Mod
    ValuesEd.Selection := SelGridRect(1,24);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,25]) = false then begin
    AllOk := false;
    //Duration Mod
    ValuesEd.Selection := SelGridRect(1,25);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,26]) = false then begin
    AllOk := false;
    //Complex
    ValuesEd.Selection := SelGridRect(1,26);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckShopInfo(ValuesEd.Cells[1,27]) = false then begin
    AllOk := false;
    //- 
    ValuesEd.Selection := SelGridRect(1,27);
    ErrorMsgStr := '    .      ,  ,      (   )';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,28]) = false then begin
    AllOk := false;
    //Unknown2
    ValuesEd.Selection := SelGridRect(1,28);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,29]) = false then begin
    AllOk := false;
    //Unknown3
    ValuesEd.Selection := SelGridRect(1,29);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,30]) = false then begin
    AllOk := false;
    //Unknown4
    ValuesEd.Selection := SelGridRect(1,30);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,31]) = false then begin
    AllOk := false;
    //Unknown5
    ValuesEd.Selection := SelGridRect(1,31);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,32]) = false then begin
    AllOk := false;
    //Unknown2
    ValuesEd.Selection := SelGridRect(1,32);
    ErrorMsgStr := '    .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,1]);
    Zap1.ReWriteField(1,Length(BufSt),BufSt);

    //Code.  2. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,2]);
    Zap1.ReWriteField(2,Length(BufSt),BufSt);

    //SubType.  3. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,3]);
    Zap1.ReWriteField(3,Length(BufSt),BufSt);

    //Price.  4. FLOAT.
    Zap1.ReWriteField(4,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,4])));

    //TypeID.  5. UnsLong.    .
    Zap1.ReWriteField(5,4,UnsLongTo4byteStr(StrToInt(FilterValue(ValuesEd.Cells[1,5]))));

    //Mana.  6. FLOAT.
    Zap1.ReWriteField(6,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,6])));

    //Slots.  7. UnsLong.
    Zap1.ReWriteField(7,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,7])));

    //Speed.  8. FLOAT.
    Zap1.ReWriteField(8,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,8])));

    //Range.  9. FLOAT.
    Zap1.ReWriteField(9,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,9])));

    //Area.  10. FLOAT.
    Zap1.ReWriteField(10,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,10])));

    //Effect.  11. FLOAT.
    Zap1.ReWriteField(11,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11])));

    //Target.  12. 4bTEXT.
    BufSt := StrTo4bTEXT(ValuesEd.Cells[1,12]);
    Zap1.ReWriteField(12,Length(BufSt),BufSt);

    //Num Targets.  13. UnsLong.
    Zap1.ReWriteField(13,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,13])));

    //Duration.  14. UnsLong.
    Zap1.ReWriteField(14,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,14])));

    //Actions.  15. UnsLong.
    Zap1.ReWriteField(15,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,15])));

    //Require Trace.  16. UnsLong.
    Zap1.ReWriteField(16,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,16])));

    //Built-in Mods.  17. 4bTEXTList.
    BufSt := ListTo4bTEXTStr(ValuesEd.Cells[1,17]);
    Zap1.ReWriteField(17,Length(BufSt),BufSt);

    //Special Mods.  18. 4bTEXTList.
    BufSt := ListTo4bTEXTStr(ValuesEd.Cells[1,18]);
    Zap1.ReWriteField(18,Length(BufSt),BufSt);

    //Texture Type Index.  19. UnsLong.
    Zap1.ReWriteField(19,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,19])));

    //Unknown1.  20. UnsLong.
    Zap1.ReWriteField(20,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,20])));

    //Mods.  21. 5 BOOLEAN .
    BufSt := '';
    //Range Mod
    BufSt := BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,21]));
    //Targets Mod
    BufSt := BufSt+BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,22]));
    //Area Mod
    BufSt := BufSt+BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,23]));
    //Effect Mod
    BufSt := BufSt+BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,24]));
    //Duration Mod
    BufSt := BufSt+BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,25]));
    Zap1.ReWriteField(21,5,BufSt);

    //Complex.  22. UnsLong.
    Zap1.ReWriteField(22,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,26])));

    //ShopInfo.  23.
    Zap1.ReWriteField(23,4,UnsLongTo4byteStr(ShopInfoToUnsLong(ValuesEd.Cells[1,27])));

    //Unknown2.  24. FLOAT.
    Zap1.ReWriteField(24,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,28])));

    //Unknown3.  25. FLOAT.
    Zap1.ReWriteField(25,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,29])));

    //Unknown4.  26. FLOAT.
    Zap1.ReWriteField(26,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,30])));

    //Unknown5.  27. FLOAT.
    Zap1.ReWriteField(27,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,31])));

    //Unknown6.  28. FLOAT.
    Zap1.ReWriteField(28,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,32])));

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSpellsSdbR1F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[4].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TSpellsSdbR1F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[4].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to SpellsSdbR1F.MaskiBox.Items.Capacity-1 do begin
    If SpellsSdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to SpellsSdbR1F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If SpellsSdbR1F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TSpellsSdbR1F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TSpellsSdbR1F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TSpellsSdbR1F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TSpellsSdbR1F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TSpellsSdbR1F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSpellsSdbR1F.ValuesEdEditButtonClick(Sender: TObject);
var
  BufSt : string;
  Idx : Integer;
  
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin

    If ValuesEd.Row = 5 then begin
      //       ...
      //  -  ...
      Idx := 0; //  ....
      If FilterValue(ValuesEd.Cells[1,5]) = '0' then begin
        Idx := 0;
      end;
      If FilterValue(ValuesEd.Cells[1,5]) = '1' then begin
        Idx := 1;
      end;
      If FilterValue(ValuesEd.Cells[1,5]) = '2' then begin
        Idx := 2;
      end;
      BufSt := SelectValueEx('0     ELEMENTAL'+#13+'1     SENSES'+#13+'2     ASTRAL'+#13,Idx);
      If BufSt <> #13 then begin
        //    ...
        ValuesEd.Cells[1,5] := BufSt;
      end;
    end;

  end;
end;

procedure TSpellsSdbR1F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
