///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit TextsOptForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, PzEd, MySys, KOL;

type
  TTextsOptF = class(TForm)
    PathEd: TEdit;
    Label1: TLabel;
    BrowseBut: TButton;
    OkBut: TButton;
    CancelBut: TButton;
    TextsResBut: TButton;
    TextslmpResBut: TButton;
    procedure CancelButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BrowseButClick(Sender: TObject);
    procedure OkButClick(Sender: TObject);
    procedure TextsResButClick(Sender: TObject);
    procedure TextslmpResButClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TextsOptF: TTextsOptF;

implementation

uses BrowseDirForm;

{$R *.DFM}

procedure TTextsOptF.CancelButClick(Sender: TObject);
begin
  ModalResult := MrCancel;
end;

procedure TTextsOptF.FormShow(Sender: TObject);
begin
  //   -       
  PathEd.Text := TextsEdStart;
end;

procedure TTextsOptF.BrowseButClick(Sender: TObject);
var
  ODD1 : POpenDirDialog;
begin
  //   -    ...

  // ...
  ODD1 := NewOpenDirDialog(' ',[]);
  If DirectoryExists(PathEd.Text) = true then begin
    ODD1.InitialPath := PathEd.Text;
  end
  else begin
    ODD1.InitialPath := DefalDir;
  end;
  ODD1.WndOwner := Application.Handle;  // " "...

  //        -  .
  If ODD1.Execute = true then begin
    PathEd.Text := AddLastSlash(ODD1.Path);
  end;

  //  ...
  ODD1.Free;
end;

procedure TTextsOptF.OkButClick(Sender: TObject);
begin
  //       ...
  PathEd.Text := AddLastSlash(PathEd.Text);
  TextsEdStart := PathEd.Text;
  AnIniFil.Load(IniFilPath);  // .
  AnIniFil.WriteString('MainSettings','TextsEdStart',TextsEdStart);
  AnIniFil.Save(IniFilPath);  // .    :)

  ModalResult := mrOk;
end;

procedure TTextsOptF.TextsResButClick(Sender: TObject);
begin
  //   -         texts.res
  PathEd.Text := GetExtensDirName(TextsResPath);
end;

procedure TTextsOptF.TextslmpResButClick(Sender: TObject);
begin
  //   -         textslmp.res
  PathEd.Text := GetExtensDirName(TextslmpResPath);
end;

procedure TTextsOptF.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //ShowMessage('');   //      watch-,  .

  //       :).
  If Key = #13 then begin
    //Enter
    OkButClick(Sender);
    //    ...
    Key := #0;
  end;

  If Key = #27 then begin
    //Escape
    CancelButClick(Sender);
    //    ...
    Key := #0;
  end;
end;

end.
